#include <alloca.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

#define DISTCC		"/usr/bin/distcc"
#define REAL_PATH	"/usr/lib/crosscc:"
#define REMOTE_GCC	"m68k-linux-gnu-gcc-4.1"
#define REMOTE_GPP	"m68k-linux-gnu-g++-4.1"

int main(int ac, char **av)
{
	char **av2 = alloca((ac + 2) * sizeof(char *));
	char *path, *path2;

	memcpy(av2 + 2, av + 1, (ac - 1) * sizeof(char *));
	av2[ac + 1] = NULL;
	av2[0] = DISTCC;
	av2[1] = strchr(strrchr(av[0], '/') ?: av[0], '+') ? REMOTE_GPP : REMOTE_GCC;

	path = getenv("PATH");
	path2 = alloca(strlen(path) + 128);
	strcpy(path2, REAL_PATH);
	strcat(path2, path);
	setenv("PATH", path2, 1);

	return execv(av2[0], av2);
}

